void zLable() {
  pushMatrix(); 
  translate(-20, 0, -105);
  rotateY(HALF_PI*1.1);
  rotateX(HALF_PI*1.05);
  stroke(255, 0.25);
  textFont(f);
  textSize(5);
  textAlign(LEFT, TOP); 
  text("Age at trial", 0, 0, 0);
  popMatrix();
}

void zLable2() {
  pushMatrix(); 
  translate(-31, -105, 0);
  //rotateZ(HALF_PI*1.05);
  rotateZ(-HALF_PI*1.15);
  stroke(255, 0.25);
  textFont(f);
  textSize(5);
  textAlign(LEFT, CENTER); 
  text("Age at trial", 0, 0, 0);
  popMatrix();
}


void longLable() {
  pushMatrix(); 
  translate(105, 0, 0);
  stroke(255, 0.25);
  textFont(f);
  textSize(5);
  textAlign(LEFT, CENTER); 
  text("Personal ID", 0, 0, 0);
  popMatrix();
}

void latLable() {
  pushMatrix(); 
  translate(0, 105, 0);
  stroke(255, 0.25);
  textFont(f);
  textSize(5);
  textAlign(LEFT, CENTER); 
  text("Age at trial", 0, 0, 0);
  popMatrix();
}

void latLable2() {
  pushMatrix(); 
  translate(-120, -30, 0);
  stroke(255, 0.25);
  textFont(f);
  textSize(7);
  textAlign(RIGHT, CENTER); 
  text("Place of birth", 0, 0, 0);
  popMatrix();
}

void drawLatitude2() {
  // latitude - age at trial
  for (int i=0; i<312; i++) {
    int r = 100;  
    float map_nb = map(i, 0, 913, -180, 180);
    float mapped_theta = 90;

    float xx = r * sin(radians(mapped_theta)) * cos(radians(map_nb));
    float yy = r * sin(radians(mapped_theta)) * sin(radians(map_nb));
    float zz = r * cos(radians(mapped_theta));

    colorMode(HSB, 360, 100, 100, 1);
    stroke(0, 0, 100, 0.25);
    if (i<birth_list.length) line(0, 0, 0, xx, yy, zz);

    if (i<birth_list.length) {
      pushMatrix(); 
      translate(xx, yy, zz);
      stroke(255, 0.25); 
      textFont(f);
      textSize(1.5);
      textAlign(RIGHT); 
      text(birth_list[i], 0, 0, 0);
      popMatrix();
    }
  }

  for (int i=-180; i<180; i++) {
    //for(int j=-180; j<180; j+=10) { 
    for (int r=0; r<=100; r+=10) {
      float xx = r * sin(radians(90)) * cos(radians(i));
      float yy = r * sin(radians(90)) * sin(radians(i));
      float zz = r * cos(radians(90)); 

      pushMatrix();

      translate(xx, yy, zz);
      stroke(0, 0, 100, 0.25); 
      point(0, 0, 0);
      popMatrix();

      if (i==-105) {
        pushMatrix(); 
        translate(xx, yy, zz);
        rotateZ(-HALF_PI*1.15);
        textFont(f);
        textSize(3);
        textAlign(CENTER); 
        text(r, 0, 0, 0);
        popMatrix();
      }
    }
  }
} 

void drawLatitude() {
  // latitude - age at trial
  for (int i=0; i<81; i+=5) {
    int r = 100;  
    float ra = map(i, 1, 81, -180, 180);
    float mapped_theta = 90;

    float xx = r * sin(radians(mapped_theta)) * cos(radians(ra));
    float yy = r * sin(radians(mapped_theta)) * sin(radians(ra));
    float zz = r * cos(radians(mapped_theta));

    colorMode(HSB, 360, 100, 100, 1);
    stroke(0, 0, 100, 0.25);
    line(0, 0, 0, xx, yy, zz);

    pushMatrix(); 
    translate(xx, yy, zz);
    stroke(255, 0.25);  
    point(0, 0, 0);
    textFont(f);
    textSize(3);
    textAlign(CENTER);
    text(floor(i), 0, 0, 0);
    popMatrix();
  }
  for (int i=-180; i<180; i++) {
    //for(int j=-180; j<180; j+=10) { 
    for (int r=0; r<=100; r+=10) {
      float xx = r * sin(radians(90)) * cos(radians(i));
      float yy = r * sin(radians(90)) * sin(radians(i));
      float zz = r * cos(radians(90)); 

      pushMatrix();
      
      translate(xx, yy, zz);
      stroke(0, 0, 100, 0.25); 
      point(0, 0, 0);
      popMatrix();

      if (i==-105) {
        pushMatrix(); 
        translate(xx, yy, zz);
        rotateZ(-HALF_PI*1.15);
        textAlign(CENTER);
        textFont(f);
        textSize(3);
        text(r, 0, 0, 0);
        popMatrix();
      }
    }
  }
}


void drawLongitude() {
  for (int i=0; i<20629; i+=1000) {
    int ra = 100;  
    float mapped_theta = map(i, 0, 20629, -180, 180);
    float map_nb = 0;

    float xx = ra * sin(radians(mapped_theta)) * cos(radians(map_nb));
    float yy = ra * sin(radians(mapped_theta)) * sin(radians(map_nb));
    float zz = ra * cos(radians(mapped_theta));

    colorMode(HSB, 360, 100, 100, 1);
    stroke(0, 0, 100, 0.25);
    line(0, 0, 0, xx, yy, zz);

    pushMatrix(); 
    translate(xx, yy, zz);

    stroke(255, 0.25);  
    point(0, 0, 0);
    textAlign(CENTER);
    textFont(f);
    textSize(3);
    text(floor(i), 0, 0, 0);
    popMatrix();
  }
  // draw z (radius) 
  for (int i=-180; i<180; i++) {
    for (int r=0; r<=100; r+=10) {
      float xx = r * sin(radians(i)) * cos(radians(0));
      float yy = r * sin(radians(i)) * sin(radians(0));
      float zz = r * cos(radians(i)); 

      pushMatrix();

      translate(xx, yy, zz);
      stroke(0, 0, 100, 0.25); 
      point(0, 0, 0);
      popMatrix();

      if (i==-172) {
        pushMatrix(); 
        translate(xx, yy, zz);
        rotateY(HALF_PI*1.05);
        rotateX(HALF_PI*1.05);
        textAlign(CENTER);
        textFont(f);
        textSize(3); 
        text(r, 0, 0, 0);
        popMatrix();
      }
    }
  }
}
